import { EditorState, Transaction, StateField, StateCommand, StateEffect, Facet, Extension } from "@codemirror/state";
import { KeyBinding } from "@codemirror/view";
export declare const isolateHistory: import("@codemirror/state").AnnotationType<"after" | "before" | "full">;
export declare const invertedEffects: Facet<(tr: Transaction) => readonly StateEffect<any>[], readonly ((tr: Transaction) => readonly StateEffect<any>[])[]>;
interface HistoryConfig {
    minDepth?: number;
    newGroupDelay?: number;
    joinToEvent?: (tr: Transaction, isAdjacent: boolean) => boolean;
}
export declare function history(config?: HistoryConfig): Extension;
export declare const historyField: StateField<unknown>;
export declare const undo: StateCommand;
export declare const redo: StateCommand;
export declare const undoSelection: StateCommand;
export declare const redoSelection: StateCommand;
export declare const undoDepth: (state: EditorState) => number;
export declare const redoDepth: (state: EditorState) => number;
export declare const historyKeymap: readonly KeyBinding[];
export {};
